Public Class LCParser

    Private PData As String
    Private mXML As System.Xml.XmlDataDocument

    Public ErrorID As Integer = 0


    Public Structure Abonents
        Public UserName As String
        Public Login As String
        Public Tariff As String
        Public ID As Integer
    End Structure

    Public Structure MainInfo
        Public UserName As String
        Public Balance As Double
        Public Abonents() As Abonents
    End Structure

    Public Structure Connection
        Public call_begin As String
        Public call_duration As String
        Public mc_charge As String
        Public sc_charge As String
        Public serv_charge As String
        Public base As String
        Public no As String
        Public mc_tax As String
        Public sc_tax As String
        Public serv_tax As String
        Public call_id As String
        Public cb As String
        Public call_d As String
        Public type As String
    End Structure

    Public Event Error_Occured(ByVal e As Exception)
    Public Event Script_Error_Detected(ByVal ErrorCode As Integer)

    Public Property Data() As String
        Get
            Return PData
        End Get
        Set(ByVal value As String)
            Try
                PData = value
                mXML = New Xml.XmlDataDocument
                mXML.LoadXml(PData)
            Catch ex As Exception
                RaiseEvent Error_Occured(ex)
            End Try
        End Set
    End Property

    Public Function getMainInfo() As MainInfo
        Try
            Dim mNode As Xml.XmlNode
            Dim icnt As Integer = 0
            mNode = mXML.DocumentElement

            If mNode.SelectSingleNode("error").Attributes("id").InnerText = "0" Then
                '    (    )
                getMainInfo.Balance = CDbl(mNode.SelectSingleNode("balance").InnerText)
                getMainInfo.UserName = mNode.SelectSingleNode("company").InnerText

                '  
                For icnt = 0 To mNode.SelectSingleNode("abonents").SelectNodes("abonent").Count - 1
                    ReDim Preserve getMainInfo.Abonents(icnt)
                    getMainInfo.Abonents(icnt).ID = CInt(mNode.SelectSingleNode("abonents").SelectNodes("abonent").Item(icnt).Attributes("id").InnerText)
                    getMainInfo.Abonents(icnt).Login = mNode.SelectSingleNode("abonents").SelectNodes("abonent").Item(icnt).SelectSingleNode("login").InnerText
                    getMainInfo.Abonents(icnt).UserName = mNode.SelectSingleNode("abonents").SelectNodes("abonent").Item(icnt).SelectSingleNode("name").InnerText
                    getMainInfo.Abonents(icnt).Tariff = mNode.SelectSingleNode("abonents").SelectNodes("abonent").Item(icnt).SelectSingleNode("tarif").InnerText
                Next
            Else
                ErrorID = CInt(mNode.SelectSingleNode("error").Attributes("id").InnerText)
                RaiseEvent Script_Error_Detected(ErrorID)
            End If
        Catch ex As Exception
            RaiseEvent Error_Occured(ex)
        End Try
        
    End Function






End Class
