Public Class frmMaster

    Private CancelSelection As Boolean = True
    Private CurrentStep As Integer = 0
    Private LoginOK As Boolean = False
    Private XmlText As String = ""
    Private lcPass As String = ""
    Private lcLogin As String = ""
    Private AgreementInfo As LCParser.MainInfo
    Private AbonentsInfo() As LCParser.Abonents
    Private WithEvents mGet As New LCGet
    Private WithEvents mParse As New LCParser
    Private blnParseError As Boolean
    Private blnAuthError As Boolean

    Private Sub frmMaster_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cmdBack.Enabled = False
        Select Case GlobalConfiguration
            Case GlobalConfig.Citus
                lblWelcome.Text = Replace(lblWelcome.Text, "%company%", " ")
            Case GlobalConfig.Lealta
                lblWelcome.Text = Replace(lblWelcome.Text, "%company%", " ")
        End Select
    End Sub

    Private Sub cmdCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCancel.Click
        If MsgBox(" ,      LCDetalizer?", MsgBoxStyle.YesNo, " ") = MsgBoxResult.Yes Then
            Me.Close()
        End If
    End Sub

    Private Sub tabMaster_Selecting(ByVal sender As Object, ByVal e As System.Windows.Forms.TabControlCancelEventArgs) Handles tabMaster.Selecting
        e.Cancel = CancelSelection
    End Sub

    Private Sub cmdForward_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdForward.Click
        Select Case CurrentStep
            Case 0 '
                SelectStep(1)
                cmdBack.Enabled = True
                lblPassError.Text = ""
            Case 1 '  
                If Trim(txtAgreement.Text) = "" Or Trim(txtPassword.Text) = "" Then
                    lblPassError.Text = "         "
                Else
                    lcLogin = Trim(txtAgreement.Text)
                    lcPass = Trim(txtPassword.Text)
                    lblChecking.Text = "   ..."
                    cmdForward.Enabled = False
                    cmdBack.Enabled = False
                    cmdCancel.Enabled = False
                    Me.Refresh()

                    CheckInfo()
                    lblChecking.Text = ""
                    Me.Refresh()

                    cmdCancel.Enabled = True
                    cmdBack.Enabled = True
                    cmdForward.Enabled = True
                End If

            Case 2 '    ,  

            Case 3 '   

            Case 4 ' 

        End Select

    End Sub

    Private Sub ConnectError(ByVal e As Exception) Handles mGet.Error_Occured
        LoginOK = False
        lblPassError.Text = "        :" & vbNewLine & e.Message & vbNewLine & ",      ,       Firewall."
    End Sub

    Private Sub WrongXML(ByVal e As Exception) Handles mParse.Error_Occured
        lblPassError.Text = "       :" & vbNewLine & e.Message & vbNewLine & "   , ,   ."
        LoginOK = False
        blnParseError = True
    End Sub

    Private Sub AuthError(ByVal ErrCode As Integer) Handles mParse.Script_Error_Detected
        If ErrCode = 1 Then
            lblPassError.Text = "       .       ."
            blnAuthError = True ' ,   True...
        Else
            lblPassError.Text = "     . ,   .     -   ." & vbNewLine & " : " & CStr(ErrCode)
            blnParseError = True
        End If
        LoginOK = False
    End Sub

    Private Sub SelectStep(ByVal intStep As Integer)
        CancelSelection = False
        tabMaster.SelectTab(intStep)
        CancelSelection = True
        CurrentStep = intStep
    End Sub

    Private Sub CheckInfo()
        mGet.UserLogin = lcLogin
        mGet.UserPass = lcPass
        XmlText = mGet.GetURL(MainPageURL)
        If DebugMode Then frmDebug.TextBox1.Text = frmDebug.TextBox1.Text & vbNewLine & XmlText
        If Not Trim(XmlText) = "" Then
            mParse.Data = XmlText
            If Not blnAuthError And Not blnParseError Then '    -   False
                AgreementInfo = mParse.getMainInfo
                AbonentsInfo = AgreementInfo.Abonents
                LoginOK = True
                lblPassError.Text = ""
            End If
        End If
    End Sub

End Class